	PREAD = 12584960	; Constant to be changed by SH2 before program load.
	PWRTE = 12584960	; Constant to be changed by SH2 before program load.
	;------------------------------------------------------------------------ P64 PROGRAM DMA HEADER
	MVI PREAD,PL															; SH2 sets "PREAD" and "WRITE" constants before program load.
	ADD				NOP					MOV ALU,A		MOV 62,CT3			; MVI is 25-bit signed data. So it requires 3 shifts right to get high memory address in that bit depth.
	SL				NOP					MOV ALU,A		NOP					; As DSP reads data in DWORD units, the address actually must be on 4-byte boundaries,
	NOP				NOP					NOP				MOV ALL,RA0			; so we need to shift left one to get the proper address in RA0 and WA0.
	NOP				NOP					CLR A			MOV ALL,MC3			;
	MVI PWRTE,PL															;
	ADD				NOP					MOV ALU,A		NOP					; CT3 = 63. Place origin DMA READ address at RAM3 62.
	SL				NOP					MOV ALU,A		NOP					;	
	NOP				NOP					NOP				MOV ALL,WA0			;
	NOP				NOP					CLR A			MOV ALL,MC3			; CT3 = ??. Place origin DMA WRITE address at RAM3 63 [end].
	;------------------------------------------------------------------------ MATH DATA TRANSFER
	NOP				NOP					NOP				MOV 0,CT0			;
	DMA D0,MC0,12															; Objective: DMAH0 D0,MC3,12 ---> Move all requisite data in format 2X0X, 2Y0Y, 2Z0Z, 3X1X, 3Y1Y, 3Z1Z.
	;------------------------------------------------------------------------
	NOP				NOP					NOP				MOV 0,CT0			; CT0 = 0.
	NOP				NOP					NOP				MOV 0,CT1			; CT1 = 0.
	NOP				NOP					NOP				MOV 0,CT2			; CT2 = 0.
	NOP				NOP					NOP				MOV 0,CT3			; CT3 = 0.
	;------------------------------------------------------------------------ 
	;-----------------------------------------------------------------------------------------------------------------------
	;	FUNCTION SEGMENT
	;		rminusb and sminusd
	;
	;	rminusb[X] = sample2[X] - sample0[X];
	;	rminusb[Y] = sample2[Y] - sample0[Y];
	;	rminusb[Z] = sample2[Z] - sample0[Z];
	;
	;	sminusd[X] = sample3[X] - sample1[X];
	;	sminusd[Y] = sample3[Y] - sample1[Y];
	;	sminusd[Z] = sample3[Z] - sample1[Z];
	;
	;	DATA
	;		sample 0,1,2,3 -> in RAM0 in order of 2X0X, 2Y0Y, 2Z0Z, 3X1X, 3Y1Y, 3Z1Z.
	;		From RAM0 0 to RAM0 11.
	;
	;		rminusb		-> in RAM1 0-2 in order as X,Y,Z
	;		sminusd		-> in RAM2 0-2 in order as X,Y,Z
	;
	;-----------------------------------------------------------------------------------------------------------------------
	;	CT0 = 0,	CT1 = 0,	CT2 = 0,	CT3 = 0
	;	rminusb[X] = sample2[X] - sample0[X];
	;	rminusb[Y] = sample2[Y] - sample0[Y];
	;	rminusb[Z] = sample2[Z] - sample0[Z];
	;-----------------------------------------------------------------------------------------------------------------------
	;ALU			X-bus X		X-Bus P				Y-Bus Y		Y-bus A			D1-bus			; 
	NOP				mov mc0,p	NOP					NOP			NOP				nop				;1
	ad2				mov mc0,p	NOP					NOP			mov alu,a		nop				;2
	sub				mov mc0,p	NOP					NOP			mov alu,a		nop				;3
	nop				nop			nop					nop			clr a			mov all,mc1		;
	ad2				mov mc0,p	nop					nop			mov alu,a		nop				;4
	sub				mov mc0,p	nop					nop			mov alu,a		nop				;5
	NOP				NOP			NOP					NOP			clr a			mov all,mc1		;
	ad2				mov mc0,p	nop					nop			mov alu,a		nop				;6
	sub				mov mc0,p	nop					nop			mov alu,a		nop				;7
	NOP				NOP			NOP					NOP			clr a			mov all,mc1		;	
	;-----------------------------------------------------------------------------------------------------------------------
	;	CT0 = 7,	CT1 = 3,	CT2 = 0,	CT3 = 0
	;	sminusd[X] = sample3[X] - sample1[X];
	;	sminusd[Y] = sample3[Y] - sample1[Y];
	;	sminusd[Z] = sample3[Z] - sample1[Z];
	;-----------------------------------------------------------------------------------------------------------------------
	ad2				mov mc0,p	nop					nop			mov alu,a		MOV 1,CT1		;8	; CT1 selection in preparation for cross-product.
	sub				mov mc0,p	nop					nop			mov alu,a		nop				;9
	NOP				NOP			NOP					NOP			clr a			mov all,mc2		;
	ad2				mov mc0,p	nop					nop			mov alu,a		nop				;10
	sub				mov mc0,p	nop					nop			mov alu,a		nop				;11
	NOP				NOP			NOP					NOP			clr a			mov all,mc2		;
	ad2				mov mc0,p	nop					nop			mov alu,a		nop				;12
	sub				nop			nop					nop			mov alu,a		mov 0,ct0		;	; CT0 selection in preparation for inverse sqrt.
	NOP				NOP			NOP					NOP			NOP				mov all,mc2		;	
																				MOV 2,CT2		;	; CT2 selection in preparation for cross-product.
	;-----------------------------------------------------------------------------------------------------------------------
	;	CT0 = 0,	CT1 = 1,	CT2 = 2,	CT3 = 0
	;	FUNCTION SEGMENT
	;	Cross-product
	;
	;	 output[X] = slMulFX(rminusb[Y], sminusd[Z]) - slMulFX(rminusb[Z], sminusd[Y]);
	;	 output[Y] = slMulFX(rminusb[Z], sminusd[X]) - slMulFX(rminusb[X], sminusd[Z]);
	;	 output[Z] = slMulFX(rminusb[X], sminusd[Y]) - slMulFX(rminusb[Y], sminusd[X]);
	;
	;	DATA
	;		rminusb	->	RAM1 0,1,2
	;		sminusd	->	RAM2 0,1,2
	;		output	->	RAM3 0,1,2
	;	TEMPORARY DATA
	;		High-order bits of 32bit x 32bit -> RAM0 0,1,2,3,4,5
	;
	;-----------------------------------------------------------------------------------------------------------------------
	;slMulFX(rminusb[Y], sminusd[Z])	->	RAM0 0
	;-----------------------------------------------------------------------------------------------------------------------
	MOV M1,X		MOV M2,Y											;
	MOV MUL,P					mov 2,ct1								;	RAM0 will be used as a temporary location for the high-order bits of the cross product multiplication.
	ad2				mov alu,a	mov 1,ct2								;	Cross product outputs to RAM3 0-2 as X,Y,Z.
					clr a		mov alh,mc0								;
	;-----------------------------------------------------------------------------------------------------------------------
	;slMulFX(rminusb[Z], sminusd[Y])	->	RAM0 1
	;-----------------------------------------------------------------------------------------------------------------------
	mov m1,x		mov m2,y
	mov mul,p					mov 2,ct1
	ad2				mov alu,a	mov 0,ct2
					clr a		mov alh,mc0
	;-----------------------------------------------------------------------------------------------------------------------
	;slMulFX(rminusb[Z], sminusd[X])	->	RAM0 2
	;-----------------------------------------------------------------------------------------------------------------------
	mov m1,x		mov m2,y
	mov mul,p					mov 0,ct1
	ad2				mov alu,a	mov 2,ct2
					clr a		mov alh,mc0
	;-----------------------------------------------------------------------------------------------------------------------
	;slMulFX(rminusb[X], sminusd[Z])	->	RAM0 3
	;-----------------------------------------------------------------------------------------------------------------------
	mov m1,x		mov m2,y
	mov mul,p					mov 0,ct1
	ad2				mov alu,a	mov 1,ct2
					clr a		mov alh,mc0
	;-----------------------------------------------------------------------------------------------------------------------
	;slMulFX(rminusb[X], sminusd[Y])	->	RAM0 4
	;-----------------------------------------------------------------------------------------------------------------------
	mov m1,x		mov m2,y	
	mov mul,p					mov 1,ct1
	ad2				mov alu,a	mov 0,ct2
					clr a		mov alh,mc0
	;-----------------------------------------------------------------------------------------------------------------------
	;slMulFX(rminusb[Y], sminusd[X])	->	RAM0 5
	;-----------------------------------------------------------------------------------------------------------------------
	mov m1,x		mov m2,y	
	mov mul,p					mov 0,ct1
	ad2				mov alu,a	mov 0,ct2
					clr a		mov alh,mc0
								mov 0,ct0
	;-----------------------------------------------------------------------------------------------------------------------
	;	CT0 = 0,	CT1 = 0,	CT2 = 0,	CT3 = 0
	;	Multiplication done, time for subtraction and output.
	;-----------------------------------------------------------------------------------------------------------------------
	;	 output[X] = slMulFX(rminusb[Y], sminusd[Z]) - slMulFX(rminusb[Z], sminusd[Y])>>8	->	RAM3 0
	;-----------------------------------------------------------------------------------------------------------------------
		mov mc0,p
	ad2	mov mc0,p	mov alu,a	
	sub				mov alu,a
	mvi 7,LOP
	LPS
	sr				mov alu,a			; Shifting right to suppress overflows (in normalization)
					clr a		mov all,mc3
	;-----------------------------------------------------------------------------------------------------------------------
	;	 output[X] = slMulFX(rminusb[Z], sminusd[X]) - slMulFX(rminusb[X], sminusd[Z])>>8	->	RAM3 1
	;-----------------------------------------------------------------------------------------------------------------------
		mov mc0,p
	ad2	mov mc0,p	mov alu,a	
	sub				mov alu,a
	mvi 7,LOP
	LPS
	sr				mov alu,a			; Shifting right to suppress overflows
					clr a		mov all,mc3
	;-----------------------------------------------------------------------------------------------------------------------
	;	 output[X] = slMulFX(rminusb[X], sminusd[Y]) - slMulFX(rminusb[Y], sminusd[X])>>8	->	RAM3 2
	;-----------------------------------------------------------------------------------------------------------------------
		mov mc0,p
	ad2	mov mc0,p	mov alu,a	
	sub				mov alu,a
	mvi 7,LOP
	LPS
	sr				mov alu,a			; Shifting right to suppress overflows
					clr a		mov all,mc3
	MOV 0,CT3							; CT0 = 0
	;-----------------------------------------------------------------------------------------------------------------------
	;	CT0 = 0,	CT1 = 0,	CT2 = 0,	CT3 = 0
	;	FUNCTION
	;		Normalize (Fixed Point)
	;	INPUTS
	;		Cross-Product Vector
	;	OUTPUTS
	;		Normalized Vector
	;	SUB-FUNCTION
	;		Inverse Square Root
	;	BODY
	; 	static FIXED isqrt = 0;
	; 	isqrt = fxisqrt(slMulFX(cross[X],cross[X]) + slMulFX(cross[Y],cross[Y]) + slMulFX(cross[Z],cross[Z]));
	; 	normal[X] = slMulFX(isqrt, cross[X]);
	; 	normal[Y] = slMulFX(isqrt, cross[Y]);
	;	normal[Z] = slMulFX(isqrt, cross[Z]);
	;
	;	DATA
	;		isqrt 	->	RAM1 1
	;		cross	->	RAM3 0,1,2
	;-----------------------------------------------------------------------------------------------------------------------
	;	slMulFX(cross[X],cross[X]) + slMulFX(cross[Y],cross[Y]) + slMulFX(cross[Z],cross[Z])
	;		TEMPORARY DATA
	;	Square Magnitude	-> "SM"
	;		SM				->	RAM3 3
	;-----------------------------------------------------------------------------------------------------------------------
	mov m3,x		mov m3,y	
	mov mul,p								mov 1,ct3
	ad2	mov m3,x	mov m3,y	mov alu,a	; X*X
	mov mul,p								mov 2,ct3
	ad2	mov m3,x	mov m3,y	mov alu,a	; Y*Y + X*X
	mov mul,p								mov 3,ct3
	ad2							mov alu,a	; Z*Z + Y*Y + X*X
											mov alh,mc3
											mov 3,ct3
	;-----------------------------------------------------------------------------------------------------------------------
	;	FUNCTION
	;		Inverse Square Root [Fixed Point]
	;	INPUTS
	;		Square Magnitude -> "SM"
	;	OUTPUTS
	;		Approximately 1/sqrt(SM) -> "isqrt"
	;	BODY
	;		xSR = 0;
	;		pushRight = SM;
	;		msb = 0;
	;		shoffset = 0;
	;		yIsqr = 0;
	;											; We will be doing something different...
	;		while(pushRight >= 65536){			; While carry flag is 0
	;			pushRight >>=1;					; Shift LEFT.
	;			msb++;							; place++;
	;		}									; This kind of logic has no real equivalency in C since it is dependent on register logic flags.
	;											; msb = 16 - place;
	;		shoffset = (16 - ((msb)>>1));
	;		yIsqr = 1<<shoffset;
	;		xSR = SM>>1;
	;		return (slMulFX(yIsqr, (98304 - slMulFX(xSR, slMulFX(yIsqr, yIsqr)))));
	;
	;	DATA
	;		SM 			->		RAM3 03
	;		xSR			->		RAM0 0
	;		pushRight	->		Temporary in RAM0 1
	;		msb/place	-> 		Temporary in RAM0 0
	;		shoffset	->		Calculated, then used as loop counter (goes to LOP)
	;		yIsqr		->		RAM1 0
	;		Return		->		RAM1 1
	;		
	;-----------------------------------------------------------------------------------------------------------------------
	;	CT0 = 0,	CT1 = 0,	CT2 = 0,	CT3 = 3
	;											; We will be doing something different...
	;		while(pushRight >= 65536){			; While carry flag is 0
	;			pushRight >>=1;					; Shift LEFT.
	;			msb++;							; place++;
	;		}									; This kind of logic has no real equivalency in C since it is dependent on register logic flags.
	;-----------------------------------------------------------------------------------------------------------------------
		mov m3,p	clr a			mov 1,ct0
	ad2				mov alu,a		
	sl				mov alu,a	
					mov all,mc0		;ct0 = 2
					mov 0,ct0		;ct0 = 0
					mvi 1,mc0		;ct0 = 1
	jmp	PUSHLCOND:
					clr a
	PUSHLEFT:
		mov m0,p
	ad2				mov alu,a		mov 1,PL
	ad2				mov alu,a		
					clr a			mov all,mc0	; ct0 = 1
		mov m0,p
	ad2				mov alu,a
	sl				mov alu,a
					clr a			mov all,mc0	; ct0 = 2
	PUSHLCOND:
	jmp NC,PUSHLEFT:
					clr a			mov 0,ct0				;(this instruction is part of the loop)
	;-----------------------------------------------------------------------------------------------------------------------
	;	CT0 = 0,	CT1 = 0,	CT2 = 0,	CT3 = 3
	;		msb = 17* - place;
	;		shoffset = (16 - ((msb)>>1));
	;		yIsqr = 1<<shoffset;
	;		xSR = SM>>1;
	;
	;	DATA
	;		msb/place 	->	RAM0 0
	;		shoffset 	->	goes to LOP
	;		yIsqr		->	RAM1 0
	;		xSR			->	RAM0 0
	;-----------------------------------------------------------------------------------------------------------------------
									mvi 17,PL				; perform 17 - place ; because our shifting output is 1 less than it should be.
	ad2	mov m0,p	mov alu,a								; select shoffset/msb/place in memory
	sub				mov alu,a								; Make MSB = 16 - place
	sr				mov alu,a								; now shift right, as MSB>>1
					clr a			mov all,mc0				; ct0 = 2
									mvi 16,PL				; Now to get shoffset, do the work to get 16 back in register A.
	ad2				mov alu,a		mov 0,ct0				; Re-select MSB
		mov m0,p											;
	sub				mov alu,a		mov 1,PL				; We need to start moving 1 to A to shift it. ; This line also makes shoffset = 16 - (msb>>1) ;
					clr a			mov all,LOP				; shoffset is just a loop counter, so it needs not be moved out to memory.
	ad2				mov alu,a								; This line modes 1 from P to A.
	LPS														;
	sl				mov alu,a		mov 0,ct0				; This makes yIsqr, the initial guess.
	sr				mov alu,a
		mov m3,p	clr a			mov all,mc1				; ct1 = 1 ; Now it is time to make xSR and store it in RAM0 0, source data RAM3 3.
	ad2				mov alu,a		mov 0,ct1				; Re-select yIsqr
	sr				mov alu,a
					clr a			mov all,mc0				; ct0 = 1
	;-----------------------------------------------------------------------------------------------------------------------
	;	CT0 = 1,	CT1 = 0,	CT2 = 0,	CT3 = 3
	;	(slMulFX(yIsqr, (98304 - slMulFX(xSR, slMulFX(yIsqr, yIsqr)))));
	;	BREAKDOWN
	;	slMulFX(yIsqr, yIsqr) -> Stored at RAM0 2
	;
	;	DATA
	;		yIsqr		->		RAM1 0
	;		xSR			->		RAM0 0
	;		98304		->		Immediate Data
	;-----------------------------------------------------------------------------------------------------------------------
		mov m1,x	mov m1,y				mov 0,ct0		; select xSR ; yIsqr^2
		mov mul,p											;
	ad2				mov alu,a								;
					mov m0,y	clr a		mov alh,RX		; yIsqr^2 * xSR
		mov mul,p											;
	ad2				mov alu,a				mov 2,ct0		;
					clr a					mov alh,mc0		; temporary storage location in ram0 2
											mvi 98304,PL	;
	ad2				mov alu,a				mov 2,ct0		;
		mov m0,p											;
	sub				mov alu,a								;
					mov m1,y	clr a		mov all,RX		; yIsqr * (98304 - result)
		mov mul,p							mov 0,ct3		;
	ad2				mov alu,a				mov 0,ct0		;
											mov alh,mc1		;
						clr a				mov alh,RX		;
											mov 0,ct1		;
	;-----------------------------------------------------------------------------------------------------------------------
	;	CT0 = 0,	CT1 = 0,	CT2 = 0,	CT3 = 0
	; That's the end of inverse sqrt. The output is in RAM1 1. And, in this demo program, the isqrt is in RX.
	;-----------------------------------------------------------------------------------------------------------------------
	; 	normal[X] = slMulFX(isqrt, cross[X]);
	; 	normal[Y] = slMulFX(isqrt, cross[Y]);
	;	normal[Z] = slMulFX(isqrt, cross[Z]);
	;
	;	DATA
	;		isqrt			->				RAM1 1 / RX
	;		poly_cross_product/normal ->	RAM3 0,1,2
	;-----------------------------------------------------------------------------------------------------------------------
	; Inverse sqrt * cross product X
	; Output in RAM3 0
	;-----------------------------------------------------------------------------------------------------------------------
					mov m3,y								; 
		mov mul,p											;
	ad2				mov alu,a								;
					clr a			mov alh,mc3				; mc3 = 1
	;-----------------------------------------------------------------------------------------------------------------------
	; Inverse sqrt * cross product Y
	; Output in RAM3 1
	;-----------------------------------------------------------------------------------------------------------------------
					mov m3,y								; 
		mov mul,p											;
	ad2				mov alu,a								;
					clr a			mov alh,mc3				; mc3 = 2
	;-----------------------------------------------------------------------------------------------------------------------
	; Inverse sqrt * cross product Z
	; Output in RAM3 2
	;-----------------------------------------------------------------------------------------------------------------------
					mov m3,y								; 
		mov mul,p											;
	ad2				mov alu,a								;
					clr a			mov alh,mc3				; mc3 = 3
	;-----------------------------------------------------------------------------------------------------------------------
	; Re-select the base of RAM3 to DMA the result out.
	;-----------------------------------------------------------------------------------------------------------------------
									mov 0,ct3
	DMA MC3,D0,3	
	END
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	